﻿Option Strict On
Option Explicit On
Imports System.Runtime.InteropServices

Module CP210x
    ' Declare statements for all the functions in the CP210x DLL
    ' NOTE: These statements assume that the DLL file is located in
    '       the same directory as this project.
    '       If you change the location of the DLL, be sure to change the location
    '       in the declare statements also.

    'GetDeviceVersion() return codes
    Public Const CP210x_CP2101_VERSION = &H1
    Public Const CP210x_CP2102_VERSION = &H2
    Public Const CP210x_CP2103_VERSION = &H3
    Public Const CP210x_CP2104_VERSION = &H4  ' <- Used at the relay board
    Public Const CP210x_CP2105_VERSION = &H5

    'Return codes
    Public Const CP210x_SUCCESS = &H0
    Public Const CP210x_DEVICE_NOT_FOUND = &HFF
    Public Const CP210x_INVALID_HANDLE = &H1
    Public Const CP210x_INVALID_PARAMETER = &H2
    Public Const CP210x_DEVICE_IO_FAILED = &H3
    Public Const CP210x_FUNCTION_NOT_SUPPORTED = &H4
    Public Const CP210x_GLOBAL_DATA_ERROR = &H5
    Public Const CP210x_FILE_ERROR = &H6
    Public Const CP210x_COMMAND_FAILED = &H8
    Public Const CP210x_INVALID_ACCESS_TYPE = &H9

    'Masks for the serial number and description
    Public Const CP210x_RETURN_SERIAL_NUMBER = &H0
    Public Const CP210x_RETURN_DESCRIPTION = &H1
    Public Const CP210x_RETURN_FULL_PATH = &H2

    ' Mask and Latch value bit definitions
    Public Const CP210x_GPIO_0 = &H1
    Public Const CP210x_GPIO_1 = &H2
    Public Const CP210x_GPIO_2 = &H4
    Public Const CP210x_GPIO_3 = &H8

    'CP210xRUNTIMEDLL_API CP210x_STATUS WINAP
    ' Read CP210x Output Latch State. 
    Public Declare Function CP210xRT_ReadLatch Lib "CP210xRuntime.dll" (ByVal Handle As UShort, ByRef Latch As Byte) As Integer
    ' Write CP210x Output Latch. Relays are switched-on at Low (0)
    Public Declare Function CP210xRT_WriteLatch Lib "CP210xRuntime.dll" (ByVal Handle As Integer, ByVal lpbMask As Byte, ByVal lpbLatch As Byte) As Integer
    ' Get Device Interface String
    Public Declare Function CP210xRT_GetDeviceInterfaceString Lib "CP210xRuntime.dll" (ByVal cyHandle As UShort, ByRef lpInterfaceString As Byte, ByRef lpbLength As Byte, bConvertToASCII As Boolean) As Integer
    ' Read Part Number (The CP2104 used at the relay board returns 4)
    Public Declare Function CP210xRT_GetPartNumber Lib "CP210xRuntime.dll" (ByVal cyHandle As UShort, ByRef lpbPartNum As Byte) As Integer
    ' Read the Serial Number of the CP210x
    Public Declare Function CP210xRT_GetDeviceSerialNumber Lib "CP210xRuntime.dll" (ByVal cyHandle As UShort, ByRef lpSerialNumber As Byte, ByRef lpbLength As Byte, ByVal bConvertToASCII As Boolean) As Integer

End Module
