﻿Imports System.Runtime.InteropServices
Imports USB_Relaycard_Timer_Application.Zeiteingabe_Feld
Imports System.IO
Imports USB_Relaycard_Timer_Application.Switchlanguage

Public Class Main
    ' Needed to create a handle for accessing the CP2104
    <DllImport("kernel32.dll")> Private Shared Function _
    CreateFile(<MarshalAs(UnmanagedType.LPStr)> ByVal lpFileName As String, _
        ByVal dwDesiredAccess As Integer, ByVal dwShareMode As Integer, _
        ByVal lpSecurityAttributes As Integer, ByVal dwCreationDisposition As Integer, _
        ByVal dwFlagsAndAttributes As Integer, ByVal hTemplateFile As Integer) As Integer
    End Function
    ' Needed to close the handle 
    <DllImport("kernel32.dll")> Private Shared Function _
         CloseHandle(ByVal hObject As Integer) As Integer
    End Function

    ' For more information please check http://msdn.microsoft.com/en-us/library/windows/desktop/aa363858%28v=vs.85%29.aspx
    Public Const GENERIC_ALL As Integer = &H10000000
    Public Const GENERIC_READ As Integer = &H80000000
    Public Const GENERIC_WRITE As Integer = &H40000000
    Public Const GENERIC_EXECUTE As Integer = &H20000000
    Public Const OPEN_EXISTING As Integer = 3
    Public Const FILE_SHARE_READ = &H1
    Public Const FILE_SHARE_WRITE = &H2
    Public Const FILE_ATTRIBUTE_NORMAL = &H80
    Public Const FILE_FLAG_OVERLAPPED = &H40000000

    'Variables used within the project
    Dim devNum As Long          'global variable to hold number of devices connected
    Dim hUSBDevice As Integer   'global handle that is set when connected with the CP210x device
    Dim Status As Integer       'status, value to set when communicating with the board to determine success

    Private Structure RandomTime_ONOFF
        Dim Time As Integer
        Dim ACTIVE As Boolean
    End Structure

    Dim Next_random_time(0 To 3) As RandomTime_ONOFF

    Public Sub New()
        InitializeComponent()
        ' Declare variables for DataColumn and DataRow objects.
    End Sub

    Private Sub Main_Load(sender As Object, e As System.EventArgs) Handles Me.Load
        Switch_Language(My.Settings.Sprache)
        hUSBDevice = CP210x_INVALID_HANDLE
        REL_OFF_QUIT.Checked = My.Settings.Relais_OFF
        List_All_Connected_Cp2104()
    End Sub

    Private Sub Set_Button_Click(sender As System.Object, e As System.EventArgs) Handles Set_Button.Click
        Dim i As Byte

        Try
            'Calculate new  CP2104 output latch value according choosen relays
            If (CB_Relais1.Checked) Then i = i Or CP210x_GPIO_0
            If (CB_Relais2.Checked) Then i = i Or CP210x_GPIO_1
            If (CB_Relais3.Checked) Then i = i Or CP210x_GPIO_2
            If (CB_Relais4.Checked) Then i = i Or CP210x_GPIO_3
            i = i Xor &HFF
            Switch_Relays(i)

        Catch ex As Exception
            MsgBox(ex.ToString, MsgBoxStyle.Critical)
        End Try
    End Sub

    Private Sub Read_Button_Click(sender As System.Object, e As System.EventArgs) Handles Read_Button.Click
        Dim latch_state_recieved, relais_states As Byte
        Dim sPort As String

        Rel4_STAT.Checked = False
        Rel3_STAT.Checked = False
        Rel2_STAT.Checked = False
        Rel1_STAT.Checked = False

        Try
            If Detected_Relayboards_Combobox.SelectedItem <> "" Then
                sPort = "\\.\" + Detected_Relayboards_Combobox.SelectedItem
                hUSBDevice = CreateFile(sPort, GENERIC_READ Or GENERIC_WRITE, 0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL Or FILE_FLAG_OVERLAPPED, 0)
                CP210xRT_ReadLatch(hUSBDevice, latch_state_recieved)
                CloseHandle(hUSBDevice)
                ' decode recieved latch-state to checkboxes
                relais_states = &HF And (Not (latch_state_recieved))    ' invert recieved state (relays are switched on aot low state) and mask out high-nibble
                If (relais_states And CP210x_GPIO_0) = CP210x_GPIO_0 Then Rel1_STAT.Checked = True
                If (relais_states And CP210x_GPIO_1) = CP210x_GPIO_1 Then Rel2_STAT.Checked = True
                If (relais_states And CP210x_GPIO_2) = CP210x_GPIO_2 Then Rel3_STAT.Checked = True
                If (relais_states And CP210x_GPIO_3) = CP210x_GPIO_3 Then Rel4_STAT.Checked = True
            Else
                If My.Settings.Sprache = "D" Then
                    MsgBox("Keine Relaiskarte ausgewählt", MsgBoxStyle.Critical, "Verbindungsaufbau zur Relaiskarte fehlgeschlagen")
                Else
                    MsgBox("No relaycard selected", MsgBoxStyle.Critical, "Cannot connect to relaycard")
                End If
            End If

        Catch ex As Exception
            MsgBox(ex.ToString, MsgBoxStyle.Critical)
        End Try
    End Sub

    Private Sub Detected_Relayboards_Combobox_Click(sender As System.Object, e As System.EventArgs) Handles Detected_Relayboards_Combobox.Click
        List_All_Connected_Cp2104()
    End Sub

    Private Sub Exit_ToolStripMenuItem_Click(sender As System.Object, e As System.EventArgs) Handles Exit_ToolStripMenuItem.Click
        Timer_Sequence.Stop()
        Timer_Randomized_Switching.Stop()
        Me.Close()
    End Sub

    Private Sub Timer_Sequence_Tick(sender As System.Object, e As System.EventArgs) Handles Timer_Sequence.Tick
        Dim Systemtime As Date = My.Computer.Clock.LocalTime
        Dim System_Time As UInteger = Systemtime.Hour * 3600 + Systemtime.Minute * 60 + Systemtime.Second
        Dim Compare_Time As UInteger
        Dim i As Byte

        Try
            If Main_Tab_CTRL.SelectedIndex = 1 Then
                For Each set_time As Switch_time In TagesPRG_Input.Schaltzeiten
                    Compare_Time = (set_time.HH * 3600 + set_time.MM * 60 + set_time.SS)
                    If set_time.ONOFF = True And Compare_Time = System_Time Then

                        'Calculate new  CP2104 output latch value according choosen relays
                        If (set_time.REL1) Then i = i Or CP210x_GPIO_0
                        If (set_time.REL2) Then i = i Or CP210x_GPIO_1
                        If (set_time.REL3) Then i = i Or CP210x_GPIO_2
                        If (set_time.REL4) Then i = i Or CP210x_GPIO_3
                        i = i Xor &HFF
                        Switch_Relays(i)
                    End If

                Next
            ElseIf Main_Tab_CTRL.SelectedIndex = 2 Then

                For ii As Byte = 0 To 6
                    For Each X As Control In TAB_Wochenprg.TabPages.Item(ii).Controls

                        If X.GetType.Name = GetType(Zeiteingabe_Feld).Name Then
                            Dim xx As Zeiteingabe_Feld = X
                            If xx.Wochentag = My.Computer.Clock.LocalTime.DayOfWeek Then
                                For Each set_time As Switch_time In xx.Schaltzeiten
                                    Compare_Time = (set_time.HH * 3600 + set_time.MM * 60 + set_time.SS)
                                    If set_time.ONOFF = True And Compare_Time = System_Time Then

                                        'Calculate new  CP2104 output latch value according choosen relays
                                        If (set_time.REL1) Then i = i Or CP210x_GPIO_0
                                        If (set_time.REL2) Then i = i Or CP210x_GPIO_1
                                        If (set_time.REL3) Then i = i Or CP210x_GPIO_2
                                        If (set_time.REL4) Then i = i Or CP210x_GPIO_3
                                        i = i Xor &HFF

                                        Switch_Relays(i)

                                    End If
                                Next
                            End If
                        End If
                    Next
                Next
            End If
        Catch ex As Exception
            Timer_Sequence.Stop()
            MsgBox(ex.ToString, MsgBoxStyle.Critical)
        End Try
    End Sub


    Private Sub CB_DAY_TIMER_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles CB_DAY_TIMER.CheckedChanged
        If CB_DAY_TIMER.Checked Then
            Timer_Randomized_Switching.Stop()
            Timer_Sequence.Start()
            Me.BackColor = Color.LightGreen
            CB_DAY_TIMER.BackColor = Color.LimeGreen
            If My.Settings.Sprache = "D" Then
                CB_DAY_TIMER.Text = "Zeitschaltuhr aktiv"
            Else
                CB_DAY_TIMER.Text = "Time Switch Active"
            End If
            TagesPRG_Input.Enabled = False
            Load_Wochenprg.Enabled = False
            Save_Wochenprg.Enabled = False
            Load_Tagesprg.Enabled = False
            Save_Tagesprg.Enabled = False
            Montag.Enabled = False
            Dienstag.Enabled = False
            Mittwoch.Enabled = False
            Donnerstag.Enabled = False
            Freitag.Enabled = False
            Samstag.Enabled = False
            Sonntag.Enabled = False
            SetRelays_Groupbox.Enabled = False
            CB_WEEK_TIMER.Enabled = False
            CB_Random_Timer.Enabled = False
            Reset_TAGESPRG.Enabled = False
            Reset_WOCHENPRG.Enabled = False
            Detected_Relayboards_Combobox.Enabled = False
        Else
            Timer_Sequence.Stop()
            Me.BackColor = System.Drawing.SystemColors.Control
            CB_DAY_TIMER.BackColor = Color.Salmon
            If My.Settings.Sprache = "D" Then
                CB_DAY_TIMER.Text = "Zeitschaltuhr aktivieren"
            Else
                CB_DAY_TIMER.Text = "Activate Time Switch"
            End If
            TagesPRG_Input.Enabled = True
            Load_Wochenprg.Enabled = True
            Save_Wochenprg.Enabled = True
            Load_Tagesprg.Enabled = True
            Save_Tagesprg.Enabled = True
            Montag.Enabled = True
            Dienstag.Enabled = True
            Mittwoch.Enabled = True
            Donnerstag.Enabled = True
            Freitag.Enabled = True
            Samstag.Enabled = True
            Sonntag.Enabled = True
            SetRelays_Groupbox.Enabled = True
            CB_WEEK_TIMER.Enabled = True
            CB_Random_Timer.Enabled = True
            Reset_TAGESPRG.Enabled = True
            Reset_WOCHENPRG.Enabled = True
            Detected_Relayboards_Combobox.Enabled = True
        End If
    End Sub

    Private Sub CB_Week_TIMER_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles CB_WEEK_TIMER.CheckedChanged
        If CB_WEEK_TIMER.Checked Then
            Timer_Randomized_Switching.Stop()
            Timer_Sequence.Start()
            Me.BackColor = Color.LightGreen
            CB_WEEK_TIMER.BackColor = Color.LimeGreen
            If My.Settings.Sprache = "D" Then
                CB_WEEK_TIMER.Text = "Zeitschaltuhr aktiv"
            Else
                CB_WEEK_TIMER.Text = "Time Switch Active"
            End If
            TagesPRG_Input.Enabled = False
            Load_Wochenprg.Enabled = False
            Save_Wochenprg.Enabled = False
            Load_Tagesprg.Enabled = False
            Save_Tagesprg.Enabled = False
            Montag.Enabled = False
            Dienstag.Enabled = False
            Mittwoch.Enabled = False
            Donnerstag.Enabled = False
            Freitag.Enabled = False
            Samstag.Enabled = False
            Sonntag.Enabled = False
            SetRelays_Groupbox.Enabled = False
            CB_DAY_TIMER.Enabled = False
            CB_Random_Timer.Enabled = False
            Reset_TAGESPRG.Enabled = False
            Reset_WOCHENPRG.Enabled = False
            Detected_Relayboards_Combobox.Enabled = False
        Else
            Timer_Sequence.Stop()
            Me.BackColor = System.Drawing.SystemColors.Control
            CB_WEEK_TIMER.BackColor = Color.Salmon
            If My.Settings.Sprache = "D" Then
                CB_WEEK_TIMER.Text = "Zeitschaltuhr aktivieren"
            Else
                CB_WEEK_TIMER.Text = "Activate Time Switch"
            End If
            TagesPRG_Input.Enabled = True
            Load_Wochenprg.Enabled = True
            Save_Wochenprg.Enabled = True
            Load_Tagesprg.Enabled = True
            Save_Tagesprg.Enabled = True
            Montag.Enabled = True
            Dienstag.Enabled = True
            Mittwoch.Enabled = True
            Donnerstag.Enabled = True
            Freitag.Enabled = True
            Samstag.Enabled = True
            Sonntag.Enabled = True
            SetRelays_Groupbox.Enabled = True
            CB_DAY_TIMER.Enabled = True
            CB_Random_Timer.Enabled = True
            Reset_TAGESPRG.Enabled = True
            Reset_WOCHENPRG.Enabled = True
            Detected_Relayboards_Combobox.Enabled = False
        End If
    End Sub

    Private Sub REL_OFF_QUIT_Click(sender As System.Object, e As System.EventArgs) Handles REL_OFF_QUIT.CheckedChanged
        My.Settings.Relais_OFF = REL_OFF_QUIT.Checked
        My.Settings.Save()
    End Sub

    Private Sub List_All_Connected_Cp2104()
        Dim sPort As String  'string representing port
        Dim i, device_type As Byte

        Detected_Relayboards_Combobox.Items.Clear()
        Try
            ' List all connected CP2104 devices connected to system
            For i = 1 To 254
                sPort = "\\.\COM" + i.ToString
                hUSBDevice = CreateFile(sPort, GENERIC_READ Or GENERIC_WRITE, 0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL Or FILE_FLAG_OVERLAPPED, 0)
                If hUSBDevice <> -1 Then    ' Got a correct handle
                    If CP210x_SUCCESS = CP210xRT_GetPartNumber(hUSBDevice, device_type) Then ' Read Part-Nr using the handle
                        If device_type = CP210x_CP2104_VERSION Then Detected_Relayboards_Combobox.Items.Add("COM" + i.ToString) ' Filter for CP2104 devices
                    End If
                End If
                CloseHandle(hUSBDevice)
            Next
            If Detected_Relayboards_Combobox.Items.Count = 0 Then
                If My.Settings.Sprache = "D" Then
                    MsgBox("Keine Relaiskarte erkannt", MsgBoxStyle.Critical, "Verbindungsaufbau zur Relaiskarte nicht möglich")
                Else
                    MsgBox("No relaycard detected", MsgBoxStyle.Critical, "Cannot connect to relaycard")
                End If
                CB_Random_Timer.Enabled = False
                CB_WEEK_TIMER.Enabled = False
                CB_DAY_TIMER.Enabled = False
                Set_Button.Enabled = False
                Read_Button.Enabled = False
            Else
                CB_Random_Timer.Enabled = True
                CB_WEEK_TIMER.Enabled = True
                CB_DAY_TIMER.Enabled = True
                Set_Button.Enabled = True
                Read_Button.Enabled = True
                Detected_Relayboards_Combobox.SelectedIndex = 0
            End If

        Catch ex As Exception
            MsgBox(ex.ToString, MsgBoxStyle.Critical)
        End Try
    End Sub

    Public Sub Save_Tages_Setup() Handles Save_Tagesprg.Click
        ' Configure save file dialog box
        Dim dlg As New SaveFileDialog()
        dlg.FileName = "Default" ' Default file name
        dlg.DefaultExt = ".dsq" ' Default file extension
        dlg.Filter = "day timer sequence (.dsq)|*.dsq" ' Filter files by extension
        ' Show save file dialog box
        ' Process save file dialog box results
        With TagesPRG_Input
            If dlg.ShowDialog = DialogResult.OK Then
                Dim Dataout As New StreamWriter(dlg.FileName, False, System.Text.ASCIIEncoding.UTF32)
                Try
                    For i As Byte = 0 To 9
                        Dataout.Write("Day;" _
                                      + .Schaltzeiten(i).ONOFF.ToString + ";" _
                                      + .Schaltzeiten(i).HH.ToString + ";" _
                                      + .Schaltzeiten(i).MM.ToString + ";" _
                                      + .Schaltzeiten(i).SS.ToString + ";" _
                                      + .Schaltzeiten(i).REL1.ToString + ";" _
                                      + .Schaltzeiten(i).REL2.ToString + ";" _
                                      + .Schaltzeiten(i).REL3.ToString + ";" _
                                      + .Schaltzeiten(i).REL4.ToString + vbNewLine)
                    Next
                    Dataout.Flush()
                    Dataout.Close()
                Catch ex As Exception
                    Dataout.Close()
                    MsgBox(ex.ToString, MsgBoxStyle.Critical, "Cannot save data")
                End Try
            End If
        End With
    End Sub

    Private Sub Save_Wochenprg_Click(sender As System.Object, e As System.EventArgs) Handles Save_Wochenprg.Click
        ' Configure save file dialog box
        Dim dlg As New SaveFileDialog()
        Dim xx As Zeiteingabe_Feld
        dlg.FileName = "Default" ' Default file name
        dlg.DefaultExt = ".wsq" ' Default file extension
        dlg.Filter = "week-timer sequence (.wsq)|*.wsq" ' Filter files by extension

        If dlg.ShowDialog = DialogResult.OK Then
            Dim Dataout As New StreamWriter(dlg.FileName, False)
            Try
                ' Show save file dialog box
                ' Process save file dialog box results
                For ii As Byte = 0 To 6
                    For Each X As Control In TAB_Wochenprg.TabPages.Item(ii).Controls
                        If X.GetType.Name = GetType(Zeiteingabe_Feld).Name Then
                            xx = X
                            With xx
                                For i As Byte = 0 To 9
                                    Dataout.Write(.Wochentag.ToString + ";" _
                                                  + .Schaltzeiten(i).ONOFF.ToString + ";" _
                                                  + .Schaltzeiten(i).HH.ToString + ";" _
                                                  + .Schaltzeiten(i).MM.ToString + ";" _
                                                  + .Schaltzeiten(i).SS.ToString + ";" _
                                                  + .Schaltzeiten(i).REL1.ToString + ";" _
                                                  + .Schaltzeiten(i).REL2.ToString + ";" _
                                                  + .Schaltzeiten(i).REL3.ToString + ";" _
                                                  + .Schaltzeiten(i).REL4.ToString + vbNewLine)
                                    Dataout.Flush()
                                Next
                            End With
                        End If
                    Next
                Next
                Dataout.Close()
            Catch ex As Exception
                Dataout.Close()
                MsgBox(ex.ToString, MsgBoxStyle.Critical, "Cannot save data")
            End Try
        End If
    End Sub

    Private Sub Load_Tagesnprg_Click(sender As System.Object, e As System.EventArgs) Handles Load_Tagesprg.Click
        Dim temp_sw_times(0 To 9) As Switch_time

        ' Configure save file dialog box
        Dim dlg As New OpenFileDialog()
        Dim VariableStr(10) As String
        dlg.FileName = "Default" ' Default file name
        dlg.DefaultExt = ".dsq" ' Default file extension
        dlg.Filter = "day timer sequence (.dsq)|*.dsq" ' Filter files by extension
        Try
            ' Show save file dialog box
            ' Process save file dialog box results
            If dlg.ShowDialog = DialogResult.OK Then
                Dim DataIn As New StreamReader(dlg.FileName, System.Text.ASCIIEncoding.UTF32)
                Dim Row As String

                For i As Byte = 0 To 9
                    Row = DataIn.ReadLine()
                    VariableStr = (Row.Split(";"))
                    temp_sw_times(i).ONOFF = Convert.ToBoolean(VariableStr(1))
                    temp_sw_times(i).HH = Convert.ToByte(VariableStr(2))
                    temp_sw_times(i).MM = Convert.ToByte(VariableStr(3))
                    temp_sw_times(i).SS = Convert.ToByte(VariableStr(4))
                    temp_sw_times(i).REL1 = Convert.ToBoolean(VariableStr(5))
                    temp_sw_times(i).REL2 = Convert.ToBoolean(VariableStr(6))
                    temp_sw_times(i).REL3 = Convert.ToBoolean(VariableStr(7))
                    temp_sw_times(i).REL4 = Convert.ToBoolean(VariableStr(8))
                Next
                Select Case VariableStr(0)
                    Case "Day"
                        TagesPRG_Input.Schaltzeiten = temp_sw_times
                    Case Else
                        MsgBox("Wrong filetype", MsgBoxStyle.Exclamation)
                End Select
                DataIn.Close()
            End If
        Catch ex As Exception
            MsgBox(ex.ToString, MsgBoxStyle.Exclamation)
            End
        End Try
    End Sub

    Private Sub Load_Wochenprg_Click(sender As System.Object, e As System.EventArgs) Handles Load_Wochenprg.Click
        Dim temp_sw_times(0 To 9) As Switch_time

        ' Configure save file dialog box
        Dim dlg As New OpenFileDialog()
        Dim VariableStr(10) As String
        dlg.FileName = "Default" ' Default file name
        dlg.DefaultExt = ".wsq" ' Default file extension
        dlg.Filter = "week-timer sequence (.wsq)|*.wsq" ' Filter files by extension
        Try
            ' Show save file dialog box
            ' Process save file dialog box results
            If dlg.ShowDialog = DialogResult.OK Then
                Dim DataIn As New StreamReader(dlg.FileName, System.Text.ASCIIEncoding.ASCII)
                Dim Row As String

                For m As Byte = 0 To 6
                    For i As Byte = 0 To 9
                        Row = DataIn.ReadLine()
                        VariableStr = (Row.Split(";"))
                        temp_sw_times(i).ONOFF = Convert.ToBoolean(VariableStr(1))
                        temp_sw_times(i).HH = Convert.ToByte(VariableStr(2))
                        temp_sw_times(i).MM = Convert.ToByte(VariableStr(3))
                        temp_sw_times(i).SS = Convert.ToByte(VariableStr(4))
                        temp_sw_times(i).REL1 = Convert.ToBoolean(VariableStr(5))
                        temp_sw_times(i).REL2 = Convert.ToBoolean(VariableStr(6))
                        temp_sw_times(i).REL3 = Convert.ToBoolean(VariableStr(7))
                        temp_sw_times(i).REL4 = Convert.ToBoolean(VariableStr(8))
                    Next
                    Select Case VariableStr(0)
                        Case "Monday"
                            Montag.Schaltzeiten = temp_sw_times
                        Case "Tuesday"
                            Dienstag.Schaltzeiten = temp_sw_times
                        Case "Wednesday"
                            Mittwoch.Schaltzeiten = temp_sw_times
                        Case "Thursday"
                            Donnerstag.Schaltzeiten = temp_sw_times
                        Case "Friday"
                            Freitag.Schaltzeiten = temp_sw_times
                        Case "Saturday"
                            Samstag.Schaltzeiten = temp_sw_times
                        Case "Sunday"
                            Sonntag.Schaltzeiten = temp_sw_times
                        Case Else
                            MsgBox("Wrong filetype", MsgBoxStyle.Exclamation)
                            DataIn.Close()
                            Exit Sub
                    End Select

                Next
                DataIn.Close()
            End If
        Catch ex As Exception
            MsgBox(ex.ToString, MsgBoxStyle.Exclamation)
            End
        End Try
    End Sub

    Private Sub CB_Random_Timer_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles CB_Random_Timer.CheckedChanged
        Dim x As Byte
        Dim sPort As String

        If sender.Checked Then
            Randomize()
            For i As Byte = 0 To 3
                Next_random_time(i).ACTIVE = CInt(Rnd() * 1)
                Next_random_time(i).Time = CInt((Break_Max_M.Value - Break_Min_M.Value) * Rnd()) + Break_Min_M.Value
            Next

            Label1.Text = Next_random_time(0).Time.ToString
            Label2.Text = Next_random_time(1).Time.ToString
            Label3.Text = Next_random_time(2).Time.ToString
            Label4.Text = Next_random_time(3).Time.ToString

            'Calculate new  CP2104 output latch value according choosen relays
            If (CB_R1_ACTIVE.Checked And Next_random_time(0).ACTIVE) Then x = x Or CP210x_GPIO_0
            If (CB_R2_ACTIVE.Checked And Next_random_time(1).ACTIVE) Then x = x Or CP210x_GPIO_1
            If (CB_R3_ACTIVE.Checked And Next_random_time(2).ACTIVE) Then x = x Or CP210x_GPIO_2
            If (CB_R4_ACTIVE.Checked And Next_random_time(3).ACTIVE) Then x = x Or CP210x_GPIO_3
            x = x Xor &HFF

            'Write new CP2104 output latch value according choosen relays to choosen board
            If Detected_Relayboards_Combobox.SelectedItem <> "" Then
                sPort = "\\.\" + Detected_Relayboards_Combobox.SelectedItem
                hUSBDevice = CreateFile(sPort, GENERIC_READ Or GENERIC_WRITE, 0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL Or FILE_FLAG_OVERLAPPED, 0)    'create handle (WIN32 API...)
                If CP210xRT_WriteLatch(hUSBDevice, 15, x) <> CP210x_SUCCESS Then
                    CloseHandle(hUSBDevice)
                    If My.Settings.Sprache = "D" Then
                        MsgBox("Fehler - Verbindung zur Relaiskarte verloren", MsgBoxStyle.Critical, "Verbindungsaufbau zur Relaiskarte fehlgeschlagen")
                    Else
                        MsgBox("Error - Connection to relaycard lost", MsgBoxStyle.Critical, "Cannot connect to relaycard")
                    End If
                    Exit Sub
                End If
                CloseHandle(hUSBDevice)
            End If

            Timer_Randomized_Switching.Start()
            Timer_Sequence.Stop()
            Me.BackColor = Color.LightGreen
            sender.BackColor = Color.LimeGreen

            If My.Settings.Sprache = "GB" Then
                sender.Text = "Randomized Switching Active"
            Else
                sender.Text = "Zufallsschaltung aktiv"
            End If
            Detected_Relayboards_Combobox.Enabled = False
            TagesPRG_Input.Enabled = False
            Load_Wochenprg.Enabled = False
            Save_Wochenprg.Enabled = False
            Load_Tagesprg.Enabled = False
            Save_Tagesprg.Enabled = False
            Montag.Enabled = False
            Dienstag.Enabled = False
            Mittwoch.Enabled = False
            Donnerstag.Enabled = False
            Freitag.Enabled = False
            Samstag.Enabled = False
            Sonntag.Enabled = False
            SetRelays_Groupbox.Enabled = False
            CB_WEEK_TIMER.Enabled = False
            CB_DAY_TIMER.Enabled = False
            Reset_TAGESPRG.Enabled = False
            Reset_WOCHENPRG.Enabled = False
        Else
            Timer_Randomized_Switching.Stop()
            Label1.Text = "-"
            Label2.Text = "-"
            Label3.Text = "-"
            Label4.Text = "-"
            Me.BackColor = System.Drawing.SystemColors.Control
            sender.BackColor = Color.Salmon
            If My.Settings.Sprache = "GB" Then
                sender.Text = "Activate Randomized Switching"
            Else
                sender.Text = "Zufallsschaltung aktivieren"
            End If
            Detected_Relayboards_Combobox.Enabled = True
            TagesPRG_Input.Enabled = True
            Load_Wochenprg.Enabled = True
            Save_Wochenprg.Enabled = True
            Load_Tagesprg.Enabled = True
            Save_Tagesprg.Enabled = True
            Montag.Enabled = True
            Dienstag.Enabled = True
            Mittwoch.Enabled = True
            Donnerstag.Enabled = True
            Freitag.Enabled = True
            Samstag.Enabled = True
            Sonntag.Enabled = True
            SetRelays_Groupbox.Enabled = True
            CB_WEEK_TIMER.Enabled = True
            CB_DAY_TIMER.Enabled = True
            Reset_TAGESPRG.Enabled = True
            Reset_WOCHENPRG.Enabled = True

            Try
                'Write new CP2104 output latch value according choosen relays to choosen board
                If Detected_Relayboards_Combobox.SelectedItem <> "" Then
                    sPort = "\\.\" + Detected_Relayboards_Combobox.SelectedItem
                    hUSBDevice = CreateFile(sPort, GENERIC_READ Or GENERIC_WRITE, 0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL Or FILE_FLAG_OVERLAPPED, 0)    'create handle (WIN32 API...)
                    CP210xRT_WriteLatch(hUSBDevice, &HF, &HF)   'All Relays OFF
                    CloseHandle(hUSBDevice)
                End If
            Catch ex As Exception
                MsgBox(ex.ToString, MsgBoxStyle.Critical)
            End Try
        End If

        If CB_R1_ACTIVE.Checked And Next_random_time(0).ACTIVE Then
            RadioButton1.Checked = True
        Else
            RadioButton1.Checked = False
        End If

        If CB_R2_ACTIVE.Checked And Next_random_time(1).ACTIVE Then
            RadioButton2.Checked = True
        Else
            RadioButton2.Checked = False
        End If

        If CB_R3_ACTIVE.Checked And Next_random_time(2).ACTIVE Then
            RadioButton3.Checked = True
        Else
            RadioButton3.Checked = False
        End If

        If CB_R4_ACTIVE.Checked And Next_random_time(3).ACTIVE Then
            RadioButton4.Checked = True
        Else
            RadioButton4.Checked = False
        End If
    End Sub

    Private Sub Timer2_Tick(sender As System.Object, e As System.EventArgs) Handles Timer_Randomized_Switching.Tick
        Dim x As Byte

        For i As Byte = 0 To 3
            If Next_random_time(i).Time > 0 Then
                Next_random_time(i).Time -= 1
            ElseIf Next_random_time(i).Time = 0 Then
                If Next_random_time(i).ACTIVE = True Then
                    Next_random_time(i).Time = CInt((Break_Max_M.Value - Break_Min_M.Value) * Rnd()) + Break_Min_M.Value
                    Next_random_time(i).ACTIVE = False

                Else
                    Next_random_time(i).Time = CInt((Active_Max_M.Value - Active_Min_M.Value) * Rnd()) + Active_Min_M.Value
                    Next_random_time(i).ACTIVE = True

                End If
            End If
        Next

        If CB_R1_ACTIVE.Checked And Next_random_time(0).ACTIVE Then
            RadioButton1.Checked = True
        Else
            RadioButton1.Checked = False
        End If

        If CB_R2_ACTIVE.Checked And Next_random_time(1).ACTIVE Then
            RadioButton2.Checked = True
        Else
            RadioButton2.Checked = False
        End If

        If CB_R3_ACTIVE.Checked And Next_random_time(2).ACTIVE Then
            RadioButton3.Checked = True
        Else
            RadioButton3.Checked = False
        End If

        If CB_R4_ACTIVE.Checked And Next_random_time(3).ACTIVE Then
            RadioButton4.Checked = True
        Else
            RadioButton4.Checked = False
        End If

        'Calculate new  CP2104 output latch value according choosen relays
        If (CB_R1_ACTIVE.Checked And Next_random_time(0).ACTIVE) Then x = x Or CP210x_GPIO_0
        If (CB_R2_ACTIVE.Checked And Next_random_time(1).ACTIVE) Then x = x Or CP210x_GPIO_1
        If (CB_R3_ACTIVE.Checked And Next_random_time(2).ACTIVE) Then x = x Or CP210x_GPIO_2
        If (CB_R4_ACTIVE.Checked And Next_random_time(3).ACTIVE) Then x = x Or CP210x_GPIO_3
        x = x Xor &HFF

        Switch_Relays(x)

        Label1.Text = Next_random_time(0).Time.ToString
        Label2.Text = Next_random_time(1).Time.ToString
        Label3.Text = Next_random_time(2).Time.ToString
        Label4.Text = Next_random_time(3).Time.ToString
    End Sub

    Private Sub Break_Min_M_ValueChanged(sender As System.Object, e As System.EventArgs) Handles Break_Min_M.ValueChanged
        If Break_Min_M.Value >= Break_Max_M.Value Then
            Break_Min_M.Value = Break_Max_M.Value - 1
        End If
    End Sub


    Private Sub Break_Max_M_ValueChanged(sender As System.Object, e As System.EventArgs) Handles Break_Max_M.ValueChanged
        If Break_Min_M.Value >= Break_Max_M.Value Then
            Break_Min_M.Value = Break_Max_M.Value - 1
        End If

        For i As Byte = 0 To 3
            If Next_random_time(i).ACTIVE = True And Next_random_time(i).Time > Active_Max_M.Value Then
                Next_random_time(i).Time = CInt((Active_Max_M.Value - Active_Min_M.Value) * Rnd()) + Active_Min_M.Value
            ElseIf Next_random_time(i).ACTIVE = False And Next_random_time(i).Time > Break_Max_M.Value Then
                Next_random_time(i).Time = CInt((Break_Max_M.Value - Break_Min_M.Value) * Rnd()) + Break_Min_M.Value
            End If
        Next

    End Sub

    Private Sub Active_Min_M_ValueChanged(sender As System.Object, e As System.EventArgs) Handles Active_Min_M.ValueChanged
        If Active_Min_M.Value >= Active_Max_M.Value Then
            Active_Min_M.Value = Active_Max_M.Value - 1
        End If
    End Sub

    Private Sub Active_Max_M_ValueChanged(sender As System.Object, e As System.EventArgs) Handles Active_Max_M.ValueChanged
        If Active_Min_M.Value >= Active_Max_M.Value Then
            Active_Min_M.Value = Active_Max_M.Value - 1
        End If

        For i As Byte = 0 To 3
            If Next_random_time(i).ACTIVE = True And Next_random_time(i).Time > Active_Max_M.Value Then
                Next_random_time(i).Time = CInt((Active_Max_M.Value - Active_Min_M.Value) * Rnd()) + Active_Min_M.Value
            ElseIf Next_random_time(i).ACTIVE = False And Next_random_time(i).Time > Break_Max_M.Value Then
                Next_random_time(i).Time = CInt((Break_Max_M.Value - Break_Min_M.Value) * Rnd()) + Break_Min_M.Value
            End If
        Next

    End Sub

    Private Sub RadioButton5_CheckedChanged(sender As System.Object, e As System.EventArgs)
        If RB_Intervall_Hour.Checked Then Timer_Randomized_Switching.Interval = 3600000
    End Sub

    Private Sub RadioButton7_CheckedChanged(sender As System.Object, e As System.EventArgs)
        If RB_Intervall_Minute.Checked Then Timer_Randomized_Switching.Interval = 1000
    End Sub

    Private Sub RadioButton6_CheckedChanged(sender As System.Object, e As System.EventArgs)
        If RB_Intervall_Second.Checked Then Timer_Randomized_Switching.Interval = 60000
    End Sub

    Private Sub ToolStripMenuItem2_Click(sender As System.Object, e As System.EventArgs) Handles GBToolStripMenuItem.Click
        My.Settings.Sprache = "GB"
        Switch_Language(My.Settings.Sprache)
        My.Settings.Save()
    End Sub

    Private Sub ToolStripMenuItem3_Click(sender As System.Object, e As System.EventArgs) Handles DToolStripMenuItem.Click
        My.Settings.Sprache = "D"
        Switch_Language(My.Settings.Sprache)
        My.Settings.Save()
    End Sub


    Private Sub Me_Closing _
              (ByVal sender As System.Object, _
              ByVal e As System.ComponentModel.CancelEventArgs) _
              Handles MyBase.Closing

        If My.Settings.Sprache = "D" Then
            If MessageBox.Show( _
                    "Programm beenden?", _
                    "Ungespeicherte Daten gehen verloren!", _
                    MessageBoxButtons.OKCancel, _
                    MessageBoxIcon.Question) <> DialogResult.OK Then
                e.Cancel = True
            End If
        Else
            If MessageBox.Show( _
                   "Quit Application?", _
                   "Unsaved data will be lost!", _
                   MessageBoxButtons.OKCancel, _
                   MessageBoxIcon.Question) <> DialogResult.OK Then
                e.Cancel = True
            End If
        End If

        If My.Settings.Relais_OFF = True And e.Cancel <> True Then
            Switch_Relays(&HF)  'Alle Relais AUS
        End If
    End Sub

    Private Sub Reset_TAGESPRG_Click(sender As System.Object, e As System.EventArgs) Handles Reset_TAGESPRG.Click
        If My.Settings.Sprache = "D" Then
            If MsgBox("Sind Sie sicher", MsgBoxStyle.Question Or MsgBoxStyle.OkCancel, "Eingaben gehen verloren") = MsgBoxResult.Ok Then
                Dim temp_sw_times(0 To 9) As Switch_time
                TagesPRG_Input.Schaltzeiten = temp_sw_times
            End If
        Else
            If MsgBox("Are you sure", MsgBoxStyle.Question Or MsgBoxStyle.OkCancel, "Input values will be deleted") = MsgBoxResult.Ok Then
                Dim temp_sw_times(0 To 9) As Switch_time
                TagesPRG_Input.Schaltzeiten = temp_sw_times
            End If
        End If
    End Sub


    Private Sub Button1_Click(sender As System.Object, e As System.EventArgs) Handles Reset_WOCHENPRG.Click
        If My.Settings.Sprache = "D" Then
            If MsgBox("Sind Sie sicher", MsgBoxStyle.Question Or MsgBoxStyle.OkCancel, "Eingaben gehen verloren") = MsgBoxResult.Ok Then
                Dim temp_sw_times(0 To 9) As Switch_time
                Montag.Schaltzeiten = temp_sw_times
                Dienstag.Schaltzeiten = temp_sw_times
                Mittwoch.Schaltzeiten = temp_sw_times
                Donnerstag.Schaltzeiten = temp_sw_times
                Freitag.Schaltzeiten = temp_sw_times
                Samstag.Schaltzeiten = temp_sw_times
                Sonntag.Schaltzeiten = temp_sw_times
            End If
        Else
            If MsgBox("Are you sure", MsgBoxStyle.Question Or MsgBoxStyle.OkCancel, "Input values will be deleted") = MsgBoxResult.Ok Then
                Dim temp_sw_times(0 To 9) As Switch_time
                Montag.Schaltzeiten = temp_sw_times
                Dienstag.Schaltzeiten = temp_sw_times
                Mittwoch.Schaltzeiten = temp_sw_times
                Donnerstag.Schaltzeiten = temp_sw_times
                Freitag.Schaltzeiten = temp_sw_times
                Samstag.Schaltzeiten = temp_sw_times
                Sonntag.Schaltzeiten = temp_sw_times
            End If
        End If
    End Sub

    Private Sub Switch_Relays(ByVal x As Byte)
        Dim sPort As String

        Try
            'Write new CP2104 output latch value according choosen relays to choosen board
            If Detected_Relayboards_Combobox.SelectedItem <> "" Then
                sPort = "\\.\" + Detected_Relayboards_Combobox.SelectedItem
                hUSBDevice = CreateFile(sPort, GENERIC_READ Or GENERIC_WRITE, 0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL Or FILE_FLAG_OVERLAPPED, 0)    'create handle (WIN32 API...)
                If CP210xRT_WriteLatch(hUSBDevice, 15, x) <> CP210x_SUCCESS Then
                    CloseHandle(hUSBDevice)
                    Timer_Randomized_Switching.Stop()
                    Timer_Sequence.Stop()

                    CB_DAY_TIMER.Checked = False
                    CB_WEEK_TIMER.Checked = False
                    CB_Random_Timer.Checked = False

                    If My.Settings.Sprache = "D" Then
                        MsgBox("Fehler - Verbindung zur Relaiskarte verloren", MsgBoxStyle.Critical)
                    Else
                        MsgBox("Error - Connection to relaycard lost", MsgBoxStyle.Critical)
                    End If
                    Exit Sub
                End If
                CloseHandle(hUSBDevice)
            End If
        Catch ex As Exception
            MsgBox(ex.ToString, MsgBoxStyle.Critical)
        End Try
    End Sub


    Private Sub RB_Intervall_Second_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RB_Intervall_Second.CheckedChanged, RB_Intervall_Hour.CheckedChanged, RB_Intervall_Minute.CheckedChanged
        If RB_Intervall_Second.Checked Then Timer_Randomized_Switching.Interval = 1000
        If RB_Intervall_Minute.Checked Then Timer_Randomized_Switching.Interval = 60000
        If RB_Intervall_Hour.Checked Then Timer_Randomized_Switching.Interval = 3600000
    End Sub
End Class
