﻿Imports System.IO
Imports System.ComponentModel

Public Class Zeiteingabe_Feld
    Dim GridStyleGreen As DataGridViewCellStyle
    Dim GridStyleYellow As DataGridViewCellStyle
    Dim GridStyleHeader As DataGridViewCellStyle

    Private Structure Row
        Dim ONOFF As CheckBox
        Dim HH As NumericUpDown
        Dim MM As NumericUpDown
        Dim SS As NumericUpDown
        Dim REL1 As CheckBox
        Dim REL2 As CheckBox
        Dim REL3 As CheckBox
        Dim REL4 As CheckBox
    End Structure

    Private WithEvents Timeinput_Controls As New List(Of Row)

    Public Structure Switch_time
        Dim ONOFF As Boolean
        Dim HH As Byte
        Dim MM As Byte
        Dim SS As Byte
        Dim REL1 As Boolean
        Dim REL2 As Boolean
        Dim REL3 As Boolean
        Dim REL4 As Boolean
    End Structure

    Private Switch_Times(10) As Switch_time

    Private _Wochentag As DayOfWeek
    Private _Sprache As String

    <DefaultValue(vbSunday), _
    Description("Wochentag")> _
    Public Property Wochentag() As DayOfWeek
        Get
            Return _Wochentag
        End Get
        Set(ByVal Value As DayOfWeek)
            If Wochentag <> Value Then
                _Wochentag = Value
                Me.Invalidate()
            End If
        End Set
    End Property

    <DefaultValue("D"), _
    Description("Sprache")> _
    Public Property Sprache() As String
        Get
            Return _Sprache
        End Get
        Set(ByVal Value As String)
            If Sprache <> Value Then
                _Sprache = Value
                Switch_Language(_Sprache)
            End If
        End Set
    End Property


    Public Property Schaltzeiten() As Switch_time()
        Get
            Return Switch_Times
        End Get
        Set(ByVal value() As Switch_time)
            For i As Byte = 0 To 9
                Timeinput_Controls(i).ONOFF.Checked = value(i).ONOFF
                Timeinput_Controls(i).HH.Value = value(i).HH
                Timeinput_Controls(i).MM.Value = value(i).MM
                Timeinput_Controls(i).SS.Value = value(i).SS
                Timeinput_Controls(i).REL1.Checked = value(i).REL1
                Timeinput_Controls(i).REL2.Checked = value(i).REL2
                Timeinput_Controls(i).REL3.Checked = value(i).REL3
                Timeinput_Controls(i).REL4.Checked = value(i).REL4
            Next
            Switch_Times = value
            Me.Invalidate()
        End Set
    End Property

    Public Sub New()
        ' Dieser Aufruf ist für den Designer erforderlich.
        InitializeComponent()
        ' Fügen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
        Me.SuspendLayout()
        For i As Byte = 0 To 9
            Dim Row1 As New Row
            Row1.ONOFF = New CheckBox
            Row1.HH = New NumericUpDown
            Row1.MM = New NumericUpDown
            Row1.SS = New NumericUpDown
            Row1.REL1 = New CheckBox
            Row1.REL2 = New CheckBox
            Row1.REL3 = New CheckBox
            Row1.REL4 = New CheckBox

            'Add Row to TableLayoutPanel
            Timeinput_Controls.Add(Row1)

            ' Add Eventhandler
            AddHandler Row1.ONOFF.CheckedChanged, AddressOf EventHandler
            AddHandler Row1.HH.ValueChanged, AddressOf EventHandler
            AddHandler Row1.MM.ValueChanged, AddressOf EventHandler
            AddHandler Row1.SS.ValueChanged, AddressOf EventHandler
            AddHandler Row1.REL1.CheckedChanged, AddressOf EventHandler
            AddHandler Row1.REL2.CheckedChanged, AddressOf EventHandler
            AddHandler Row1.REL3.CheckedChanged, AddressOf EventHandler
            AddHandler Row1.REL4.CheckedChanged, AddressOf EventHandler

            'Limits for Time Input Fields
            Timeinput_Controls(i).HH.Minimum = 0
            Timeinput_Controls(i).HH.Maximum = 23
            Timeinput_Controls(i).MM.Minimum = 0
            Timeinput_Controls(i).MM.Maximum = 59
            Timeinput_Controls(i).SS.Minimum = 0
            Timeinput_Controls(i).SS.Maximum = 59

            'Align Controls
            Timeinput_Controls(i).ONOFF.CheckAlign = ContentAlignment.MiddleCenter
            Timeinput_Controls(i).HH.TextAlign = HorizontalAlignment.Center
            Timeinput_Controls(i).MM.TextAlign = HorizontalAlignment.Center
            Timeinput_Controls(i).SS.TextAlign = HorizontalAlignment.Center
            Timeinput_Controls(i).HH.Margin = New System.Windows.Forms.Padding(3, 2, 3, 3)
            Timeinput_Controls(i).MM.Margin = New System.Windows.Forms.Padding(3, 2, 3, 3)
            Timeinput_Controls(i).SS.Margin = New System.Windows.Forms.Padding(3, 2, 3, 3)
            Timeinput_Controls(i).REL1.CheckAlign = ContentAlignment.MiddleCenter
            Timeinput_Controls(i).REL2.CheckAlign = ContentAlignment.MiddleCenter
            Timeinput_Controls(i).REL3.CheckAlign = ContentAlignment.MiddleCenter
            Timeinput_Controls(i).REL4.CheckAlign = ContentAlignment.MiddleCenter

            'Sort Controls into TableLayoutPanel Columns
            TableLayoutPanel1.Controls.Add(Timeinput_Controls(i).ONOFF, 0, i + 1)
            TableLayoutPanel1.Controls.Add(Timeinput_Controls(i).HH, 1, i + 1)
            TableLayoutPanel1.Controls.Add(Timeinput_Controls(i).MM, 2, i + 1)
            TableLayoutPanel1.Controls.Add(Timeinput_Controls(i).SS, 3, i + 1)
            TableLayoutPanel1.Controls.Add(Timeinput_Controls(i).REL1, 4, i + 1)
            TableLayoutPanel1.Controls.Add(Timeinput_Controls(i).REL2, 5, i + 1)
            TableLayoutPanel1.Controls.Add(Timeinput_Controls(i).REL3, 6, i + 1)
            TableLayoutPanel1.Controls.Add(Timeinput_Controls(i).REL4, 7, i + 1)

        Next
        Me.ResumeLayout()
    End Sub

    Sub EventHandler(ByVal sender As Object, e As System.EventArgs)
        For i As Byte = 0 To 9
            Switch_Times(i).ONOFF = Timeinput_Controls.Item(i).ONOFF.CheckState
            Switch_Times(i).HH = Timeinput_Controls.Item(i).HH.Value
            Switch_Times(i).MM = Timeinput_Controls.Item(i).MM.Value
            Switch_Times(i).SS = Timeinput_Controls.Item(i).SS.Value
            Switch_Times(i).REL1 = Timeinput_Controls.Item(i).REL1.CheckState
            Switch_Times(i).REL2 = Timeinput_Controls.Item(i).REL2.CheckState
            Switch_Times(i).REL3 = Timeinput_Controls.Item(i).REL3.CheckState
            Switch_Times(i).REL4 = Timeinput_Controls.Item(i).REL4.CheckState
        Next
    End Sub

    Private Sub Switch_Language(ByVal Lng As String)
        With Main
            Select Case Lng

                Case "D"
                    Label1.Text = "Aktiv"
                    Label2.Text = "Stunden"
                    Label3.Text = "Minuten"
                    Label4.Text = "Sekunden"
                Case "GB"
                    Label1.Text = "Active"
                    Label2.Text = "Hours"
                    Label3.Text = "Minutes"
                    Label4.Text = "Seconds"
                Case Else
            End Select
        End With
    End Sub
End Class
